Codeforces Round 600 (Div. 2)
E
Antenna Coverage
Codeforces
2200
原题
← DF →
翻译中…

The mayor of the Central Town wants to modernize Central Street, represented in this problem by the $(Ox)$ axis.

翻译中…

On this street, there are $n$ antennas, numbered from $1$ to $n$. The $i$-th antenna lies on the position $x_i$ and has an initial scope of $s_i$: it covers all integer positions inside the interval $[x_i - s_i; x_i + s_i]$.

翻译中…

It is possible to increment the scope of any antenna by $1$, this operation costs $1$ coin. We can do this operation as much as we want (multiple times on the same antenna if we want).

翻译中…

To modernize the street, we need to make all integer positions from $1$ to $m$ inclusive covered by at least one antenna. Note that it is authorized to cover positions outside $[1; m]$, even if it's not required.

翻译中…

What is the minimum amount of coins needed to achieve this modernization?

翻译中…

Input

翻译中…

The first line contains two integers $n$ and $m$ ($1 \le n \le 80$ and $n \le m \le 100\ 000$).

翻译中…

The $i$-th of the next $n$ lines contains two integers $x_i$ and $s_i$ ($1 \le x_i \le m$ and $0 \le s_i \le m$).

翻译中…

On each position, there is at most one antenna (values $x_i$ are pairwise distinct).

翻译中…

Output

翻译中…

You have to output a single integer: the minimum amount of coins required to make all integer positions from $1$ to $m$ inclusive covered by at least one antenna.

翻译中…

Note

翻译中…

In the first example, here is a possible strategy:

翻译中…
  • Increase the scope of the first antenna by $40$, so that it becomes $2 + 40 = 42$. This antenna will cover interval $[43 - 42; 43 + 42]$ which is $[1; 85]$
  • Increase the scope of the second antenna by $210$, so that it becomes $4 + 210 = 214$. This antenna will cover interval $[300 - 214; 300 + 214]$, which is $[86; 514]$
  • Increase the scope of the third antenna by $31$, so that it becomes $10 + 31 = 41$. This antenna will cover interval $[554 - 41; 554 + 41]$, which is $[513; 595]$
翻译中…

Total cost is $40 + 210 + 31 = 281$. We can prove that it's the minimum cost required to make all positions from $1$ to $595$ covered by at least one antenna.

翻译中…

Note that positions $513$ and $514$ are in this solution covered by two different antennas, but it's not important.

翻译中…

—

翻译中…

In the second example, the first antenna already covers an interval $[0; 2]$ so we have nothing to do.

翻译中…

Note that the only position that we needed to cover was position $1$; positions $0$ and $2$ are covered, but it's not important.

翻译中…

样例

Input #1
3 595
43 2
300 4
554 10
Output #1
281
InputCopy OutputCopy
Input #2
1 1
1 1
Output #2
0
InputCopy OutputCopy
Input #3
2 50
20 0
3 1
Output #3
30
InputCopy OutputCopy
Input #4
5 240
13 0
50 25
60 5
155 70
165 70
Output #4
26
InputCopy OutputCopy
题目信息
题号
1253E
时间限制
3 s
内存限制
256 MB
标签
数据结构
动态规划
贪心
排序

题面与样例版权归 Codeforces 及出题人所有;中文翻译由 AI 生成(CI 管线),如有出入请以原文为准。